'###############################################################################
'#                                                                             #
'#                                               ./-----o--[100]--[>]--\ LED17 #
'#       COLOR MUSIC  16 CHANNEL         /-[1 k]-|      o--[100]--[>]--o LED18 #
'#       RUNNING LIGHT 5 CHANNEL        |        '\<-\  o--[100]--[>]--o LED19 #
'#                                      |            |  \--[100]--[>]--o LED20 #
'#      Rubashka Vasiliy, Ukraine       |            |                 |       #
'#        http://ledeffects.net         |        ./--+--o--[100]--[>]--o LED21 #
'#                                      |/-[1 k]-|   |  o--[100]--[>]--o LED22 #
'#                                      |        '\<-o  o--[100]--[>]--o LED23 #
'#                                      |            |  \--[100]--[>]--o LED24 #
'#                                      |            |                 |       #
'#                                      |        ./--+--o--[100]--[>]--o LED25 #
'#                                      |/-[1 k]-|   |  o--[100]--[>]--o LED26 #
'#                                      |        '\<-o  o--[100]--[>]--o LED27 #
'#                                      |            |  \--[100]--[>]--o LED28 #
'#                                      |            |                 |       #
'#                                      |        ./--+--o--[100]--[>]--o LED29 #
'#                                      |/-[1 k]-|   |  o--[100]--[>]--o LED30 #
'#                                      |        '\<-o  o--[100]--[>]--o LED31 #
'#                                      |            |  \--[100]--[>]--o LED32 #
'#                                      |            |                 |       #
'#       ATMEGA8-16PU         .==\/==.  |        ./--+--o--[100]--[>]--o LED33 #
'#                         /--|1 ||28|-/|/-[1 k]-|   |  o--[100]--[>]--o LED34 #
'# LED01 /--|<]--[100]-----+--|2 ||27|-/|        '\<-o  o--[100]--[>]--o LED35 #
'# LED02 o--|<]--[100]-----+--|3 ||26|-/|            |  \--[100]--[>]--o LED36 #
'# LED03 o--|<]--[100]-----+--|4 ||25|-/|  5 x BC557 |                 |       #
'# LED04 o--|<]--[100]-----+--|5 ||24|-/             |                 |       #
'# LED05 o--|<]--[100]-----+--|6 ||23|---------------+-----------------+-\     #
'#       |              /--+--|7 ||22|---------------+-------\         | |     #
'#       o--------------+--+--|8 ||21|               |       |         | |     #
'# LED06 o--|<]--[100]--+--+--|9 ||20|--------o------/       |         | |     #
'# LED07 o--|<]--[100]--+--+--|10||19|------o-+--[100]--[>|--o LED12   | |     #
'# LED08 o--|<]--[100]--+--+--|11||18|----o-+-+--[100]--[>|--o LED13   | |     #
'# LED09 o--|<]--[100]--+--+--|12||17|--o-+-+-+--[100]--[>|--o LED14   | |     #
'# LED10 o--|<]--[100]--+--+--|13||16|--+-+-+-+--[100]--[>|--o LED15   | |     #
'# LED11 o--|<]--[100]--+--+--|14||15|--+-+-+-+--[100]--[>|--o LED16   | |     #
'#       |              |  |  '======'  | | | |              |         | |     #
'#       |              |  \----------\ | | | |              |         | |     #
'#       |              o----o--------+-+-+-+-o-----o------\ |         | |     #
'#       |              | 0,1|        | | | | |    +| 470,0| |         | |     #
'#       |             ---   |        | | | | |    ---     | |         | |     #
'#       |             ---   \-[10k]--o | | | |    ---     | |         | |     #
'#       |              |             | | | | |     |      | |         | |     #
'#       \--------------o-------------+-+-+-+-+-o---o------+-o---------o |     #
'#                      |             | | | | | |          | |         | |     #
'#                     ---            V V V V V V          V V         V V     #
'#                                                                             #
'#                                    R M M S V G          + -         G A     #
'#                                    E O I C C N          5 5         N U     #
'#                                    S S S K C D          V V         D D     #
'#                                                                             #
'###############################################################################

'        Y0
'     Ym1-Ym4   .

' Y0=[(y1+y5)+2(y2+y4)]/6
' Ym1=(y1-y5+y2-y4)/3
' Ym2=(y1+y5-2y3)/4
' Ym3=[(y1-y5)-2(y2-y4)]/6
' Ym4=[(y1+y5)-4(y2+y4)]/12

$regfile = "m8def.dat"
$crystal = 8000000                                          '  8
Config Portb = Output                                       ' B  
Config Portc = Output                                       ' C  
Config Portd = Output                                       ' D  
Config Pinc.0 = Input                                       ' 0   

Enable Interrupts                                           '  
Config Adc = Single , Prescaler = Auto , Reference = Internal       ' 
Enable Adc                                                  ' 
Start Adc                                                   ' 

Dim A1 As Word , A2 As Word , A3 As Word , A4 As Word , A5 As Word       '    
Dim X1 As Single , X2 As Single , X3 As Single , X4 As Single , X5 As Single       '    
Dim Ym1 As Byte , Ym2 As Byte , Ym3 As Byte , Ym4 As Byte   '    
Dim Y0 As Byte                                              '  
Dim Effect As Byte                                          '   
Dim Zaderjka As Word                                        '       
Dim Bas As Byte                                             '   B  
Dim Das As Byte                                             '   D  
Dim Zmu As Byte                                             '     ( )
Dim Red1 As Byte , Red2 As Byte , Red3 As Byte , Red4 As Byte       '  
Dim Yel1 As Byte , Yel2 As Byte , Yel3 As Byte , Yel4 As Byte       '  
Dim Grn1 As Byte , Grn2 As Byte , Grn3 As Byte , Grn4 As Byte       '  
Dim Blu1 As Byte , Blu2 As Byte , Blu3 As Byte , Blu4 As Byte       '  
Dim Ppp As Byte                                             '        
Dim Paus As Byte                                            '  ,     
Dim Podvijnost As Byte                                      '  (    )
Dim Qwerty As Byte                                          '   ,      
Dim Z1 As Byte , Z2 As Byte , Z3 As Byte , Z4 As Byte       '    
Dim Eee As Byte                                             '     
Dim Temp5 As Single , Temp6 As Single , Temp7 As Single     ' 
Dim Temp8 As Byte                                           ' 
Dim Ut1 As Byte , Ut2 As Byte , Ut3 As Byte , Ut4 As Byte   '  
Dim Shag As Byte                                            '  
Dim D As Byte                                               '      

'*******************************************************************************

Zaderjka = 330                                              '  
Paus = 20                                                   ',        
Podvijnost = 12                                             ' 
Ut1 = 60                                                    '1
Ut2 = 50                                                    '2
Ut3 = 40                                                    '3
Ut4 = 17                                                    '4
'*******************************************************************************
Do                                                          ' 
      
      ' 5    (1-5)
      A1 = Getadc(0)
      'Waitus 25
      A2 = Getadc(0)
      'Waitus 25
      A3 = Getadc(0)
      'Waitus 25
      A4 = Getadc(0)
      'Waitus 25
      A5 = Getadc(0)

      '  (0...1024)   (0...10)
      X1 = A1 / 103
      X2 = A2 / 103
      X3 = A3 / 103
      X4 = A4 / 103
      X5 = A5 / 103

      '    
         '
          Temp5 = X1 - X5
          Temp6 = X2 - X4
          Temp8 = Temp5 + Temp6
          Ym1 = Temp8 / 3
         '1
          Temp5 = X1 + X5
          Temp6 = X3 * 2
          Temp8 = Temp5 - Temp6
          Ym2 = Temp8 / 4
         '2
          Temp5 = X1 - X5
          Temp7 = X2 - X4
          Temp6 = Temp7 * 2
          Temp8 = Temp5 - Temp6
          Ym3 = Temp8 / 6
         '
          Temp5 = X1 + X5
          Temp7 = X2 + X4
          Temp6 = Temp7 * 4
          Temp8 = Temp5 - Temp6
          Ym4 = Temp8 / 12

 ' ""   
      Y0 = 0
      If Ym1 > Ut1 Then Y0 = 1
      If Ym2 > Ut2 Then Y0 = 1
      If Ym3 > Ut3 Then Y0 = 1
      If Ym4 > Ut4 Then Y0 = 1

      If Y0 = 0 Then
      Incr Ppp
        If Ppp = 255 Then
        Ppp = Paus
        End If
      Else
      Ppp = 0
      End If

'*******************************************************************************
      If Ppp < Paus Then
      '

      Portc = 62                                            '   
      Effect = Rnd(11)                                      '     
      Shag = 0                                              '     "0"

      If Ym1 > Ut1 Then                                     '      
      Select Case Zmu                                       '  
     Case 0 : Gosub Zmu1
     Case 1 : Gosub Zmu1
     Case 2 : Gosub Zmu1
     Case 3 : Gosub Zmu1
     Case 4 : Gosub Zmu1
     Case 5 : Gosub Zmu1
     Case 6 : Gosub Zmu2
     Case 7 : Gosub Zmu2
     Case 8 : Gosub Zmu2
     Case 9 : Gosub Zmu2
     Case 10 : Gosub Zmu2
     Case 11 : Gosub Zmu2
     Case 12 : Gosub Zmu3
     Case 13 : Gosub Zmu3
     Case 14 : Gosub Zmu3
     Case 15 : Gosub Zmu3
     Case 16 : Gosub Zmu3
     Case 17 : Gosub Zmu3
     Case 18 : Gosub Zmu4
     Case 19 : Gosub Zmu4
     Case 20 : Gosub Zmu4
     Case 21 : Gosub Zmu4
     Case 22 : Gosub Zmu4
     Case 23 : Gosub Zmu4
        End Select
      End If


      If Ym2 > Ut2 Then                                     '      
      Select Case Zmu                                       '  
     Case 0 : Gosub Zmu2
     Case 1 : Gosub Zmu2
     Case 2 : Gosub Zmu3
     Case 3 : Gosub Zmu3
     Case 4 : Gosub Zmu4
     Case 5 : Gosub Zmu4
     Case 6 : Gosub Zmu1
     Case 7 : Gosub Zmu1
     Case 8 : Gosub Zmu3
     Case 9 : Gosub Zmu3
     Case 10 : Gosub Zmu4
     Case 11 : Gosub Zmu4
     Case 12 : Gosub Zmu1
     Case 13 : Gosub Zmu1
     Case 14 : Gosub Zmu2
     Case 15 : Gosub Zmu2
     Case 16 : Gosub Zmu4
     Case 17 : Gosub Zmu4
     Case 18 : Gosub Zmu1
     Case 19 : Gosub Zmu1
     Case 20 : Gosub Zmu2
     Case 21 : Gosub Zmu2
     Case 22 : Gosub Zmu3
     Case 23 : Gosub Zmu3
        End Select
      End If


      If Ym3 > Ut3 Then                                     '      
      Select Case Zmu                                       '  
     Case 0 : Gosub Zmu3
     Case 1 : Gosub Zmu4
     Case 2 : Gosub Zmu2
     Case 3 : Gosub Zmu4
     Case 4 : Gosub Zmu2
     Case 5 : Gosub Zmu3
     Case 6 : Gosub Zmu3
     Case 7 : Gosub Zmu4
     Case 8 : Gosub Zmu1
     Case 9 : Gosub Zmu4
     Case 10 : Gosub Zmu1
     Case 11 : Gosub Zmu3
     Case 12 : Gosub Zmu2
     Case 13 : Gosub Zmu4
     Case 14 : Gosub Zmu1
     Case 15 : Gosub Zmu4
     Case 16 : Gosub Zmu1
     Case 17 : Gosub Zmu2
     Case 18 : Gosub Zmu2
     Case 19 : Gosub Zmu3
     Case 20 : Gosub Zmu1
     Case 21 : Gosub Zmu3
     Case 22 : Gosub Zmu1
     Case 23 : Gosub Zmu2
        End Select
      End If


      If Ym4 > Ut4 Then                                     '      
      Select Case Zmu                                       '  
     Case 0 : Gosub Zmu4
     Case 1 : Gosub Zmu3
     Case 2 : Gosub Zmu4
     Case 3 : Gosub Zmu2
     Case 4 : Gosub Zmu3
     Case 5 : Gosub Zmu2
     Case 6 : Gosub Zmu4
     Case 7 : Gosub Zmu3
     Case 8 : Gosub Zmu4
     Case 9 : Gosub Zmu1
     Case 10 : Gosub Zmu3
     Case 11 : Gosub Zmu1
     Case 12 : Gosub Zmu4
     Case 13 : Gosub Zmu2
     Case 14 : Gosub Zmu4
     Case 15 : Gosub Zmu1
     Case 16 : Gosub Zmu2
     Case 17 : Gosub Zmu1
     Case 18 : Gosub Zmu3
     Case 19 : Gosub Zmu2
     Case 20 : Gosub Zmu3
     Case 21 : Gosub Zmu1
     Case 22 : Gosub Zmu2
     Case 23 : Gosub Zmu1
        End Select
      End If

'       
  Das = Red1 + Yel1
  Das = Das + Grn2
  Das = Das + Blu2
  Das = Das + Yel3
  Das = Das + Blu4
  Das = Das + Red4
  Das = Das + Yel4

  Bas = Grn1 + Blu1
  Bas = Bas + Red2
  Bas = Bas + Yel2
  Bas = Bas + Red3
  Bas = Bas + Grn3
  Bas = Bas + Blu3
  Bas = Bas + Grn4

  Portb = Bas
  Portd = Das
'*******************************************************************************

       Else                                                 ' -     
        '  
         Portb = 0
         Portd = 0

 Zmu = Rnd(24)                                              '      


 Incr Shag                                                  '   
  If Shag = 10 Then
      Shag = 0
      Incr Eee                                              '   
          If Eee = 5 Then
            Eee = 0
            Effect = Rnd(11)                                '     
          End If
  End If

 D = 10 * Effect                                            '
 D = D + Shag
 Portc = Lookup(d , Effectdata)
 Waitms Zaderjka

End If

Loop                                                        ' 
'*******************************************************************************

Zmu1:                                                       '     ,    
      Incr Z1
        If Z1 = Podvijnost Then
        Z1 = 0
        Qwerty = Rnd(40)
        Qwerty = Qwerty / 10
        Select Case Qwerty
               Case 0 : Red1 = 4
               Case 1 : Red2 = 16
               Case 2 : Red3 = 64
               Case 3 : Red4 = 64
        End Select
        Else
               Red1 = 0
               Red2 = 0
               Red3 = 0
               Red4 = 0
        End If
Return

Zmu2:                                                       '     ,    
      Incr Z2
        If Z2 = Podvijnost Then
        Z2 = 0
        Qwerty = Rnd(40)
        Qwerty = Qwerty / 10
       Select Case Qwerty
              Case 0 : Yel1 = 2
              Case 1 : Yel2 = 2
              Case 2 : Yel3 = 16
              Case 3 : Yel4 = 128
       End Select
       Else
              Yel1 = 0
              Yel2 = 0
              Yel3 = 0
              Yel4 = 0
       End If
Return

Zmu3:                                                       '     ,    
      Incr Z3
        If Z3 = Podvijnost Then
        Z3 = 0
        Qwerty = Rnd(40)
        Qwerty = Qwerty / 10
        Select Case Qwerty
               Case 0 : Grn1 = 8
               Case 1 : Grn2 = 8
               Case 2 : Grn3 = 32
               Case 3 : Grn4 = 128
        End Select
        Else
               Grn1 = 0
               Grn2 = 0
               Grn3 = 0
               Grn4 = 0
        End If
Return

Zmu4:                                                       '     ,    
      Incr Z4
        If Z4 = Podvijnost Then
        Z4 = 0
        Qwerty = Rnd(40)
        Qwerty = Qwerty / 10
       Select Case Qwerty
              Case 0 : Blu1 = 4
              Case 1 : Blu2 = 1
              Case 2 : Blu3 = 1
              Case 3 : Blu4 = 32
       End Select
       Else
              Blu1 = 0
              Blu2 = 0
              Blu3 = 0
              Blu4 = 0
       End If
Return

Effectdata:
Data 60 , 58 , 54 , 46 , 30 , 60 , 58 , 54 , 46 , 30
Data 30 , 46 , 54 , 58 , 60 , 30 , 46 , 54 , 58 , 60
Data 0 , 2 , 6 , 14 , 30 , 62 , 60 , 56 , 48 , 32
Data 0 , 32 , 48 , 56 , 60 , 62 , 30 , 14 , 6 , 2
Data 2 , 4 , 8 , 16 , 32 , 2 , 4 , 8 , 16 , 32
Data 32 , 16 , 8 , 4 , 2 , 32 , 16 , 8 , 4 , 2
Data 6 , 12 , 24 , 48 , 34 , 6 , 12 , 24 , 48 , 34
Data 34 , 48 , 24 , 12 , 6 , 32 , 48 , 24 , 12 , 6
Data 14 , 28 , 56 , 50 , 38 , 14 , 28 , 56 , 50 , 38
Data 38 , 50 , 56 , 28 , 14 , 38 , 50 , 56 , 28 , 14
Data 10 , 20 , 40 , 18 , 36 , 10 , 20 , 40 , 18 , 36
Data 36 , 18 , 40 , 20 , 10 , 36 , 18 , 40 , 20 , 10


'*******************************************************************************

'                                 ,,lbmmma.. , ....
'                          Q@@#MMMMMMMMMMMMMMMMMMMMM
'                      oMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
'                  @@MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
'               MMMMMMMMMMMMM@M@M@@@@#@@M@@@MMMMMMMMMMMMMMMt
'            tMMMMMMMMMMMM#@#@#WB@##W####@#@MM#QZ990E@#@MMMMMM
'          YMMMMMMMMMMMMMWWQQEE9EbWQ0b$WQEEn1;:...,:ii7U#MMMMMM.
'        :MMMMMMMM@MMMM@BBEntAI9z9Io7Y7v:i:....... ..,,iiY0MMMMM6
'       ZMMMMMMM#9UXYYCYY;i,:;XCoXY;i::...:.........,......7@MMMMW
'      MMMMMM@7;,... ........,.:i:.,,:.:,,.,.,.....,.:,:,,.,S#MMMMM
'     WMMMM@z.  .  .......,.,.....,,,.,.,.,.,.....:,i:i:i:i.;nW@MMMY
'    vMMMMBY.............,.,...,.,.,.,.,,,.:...,.,:iii:i:;:::;CEW#@Mz
'    MMMM#7..:i.,.,.,.....,.......,.....,,:.,,::ii;i;:i:iii.:vnIEW@MM.
'    MMM@Ai.,i,i.,:,.,.....,.,...,...:,,.::i,i:i:iii:;iiiv;::Yt6Ab$MMM
'    MM@B7;:i,iii:i,i::.,,:.,.,.:,,.....,,::i,:.,,::ii;;;;v;;iYt99Q$MM
'    M@MUY7;:i:;i;ii:i:i::::,,,,.,.,...,,:..,,.,.,.,:i,iivcYi;;YtE0Q#M
'   .MM#UYC;i:ii;;v;;i;ii:i,,,:,..,.,..,..,.,.......,....:;i;vvicYAW@MM
'    MM#ZXYc;;iv;vi;ii,,...,.....,.........,...........,...i;ccviiYb#MM
'    UM$8XnCYi;;vii:i,....,.,.,.,.,.:...........:co900#$BU;,ii;;ci;70M
'    EM#Aotn7c;v;;,:.:.........,.,.....,.,.:1Q$MMMMMMMMM#M@@01ivvc;7IM
'    $M$$Z17ttCvv::...:......::.,...:,,,ic19@MMMMM@9znSC2S0B@$9Yvi;;zM
'    @M@Q077Ytc;,,iY760BWMM@$EX7;i:;;;:;7SSIn62AIIzUoAU9AAzU29ZA;cv;YWn
'    8MM#ocYXcc,:n#@MMMMMMMM#E8z17Y;v;cYXXUIE0B#M#@M@#@#$$$bUtnYcvc;7t@@IY0:
'     MMWSv7Yc;Y0M@M#$00bE9E8EEb2UXv:i,;;XI00$@M0oBMMM#;z@@$62Yc;ciccXoCi7n0:
'     :M0Y7Y7c9MM0EZAU96EW@@MMM@#ZSc;,,.;CU6ZAQEX.YWM@IizA6Sz7;:ii;v7cY;t6QA#:
'      M#XcYYE$#W0ZE#@@MMMMEZ#W$Q0zni..,:7oI1zI69bAIUZZ0UoSSY;:i:i;YcXYC12nnQ:
'      UM7;v7o0Z0EW@MQ0MMMM,.7bAbUz1c.,.:vtYttSSUUn1znIS1Yvii,,:;i;ctX1Ct77v@:
'      EMUicYnz0$@MMQCiIWW9A8boIoSttY;..,;;c;Y;iic;c;v;;ii,..::ii;;tXtt1Xtco#
'    ,tMM6Yvcvc79EW0062zAU86bAU1YcC77i,.::;;;iiiii;iii;ii.i:::iivv77Y7CvY;;1#
'  :Bb006EX;i;:,.ctIzU2AoS7X7tc;ivv7vv,,,::;;;:iii:::i:ii;i;iv;;;77X77c7Y;iI@
' :MoXYivt2cvii,,,::Yvci;vcivii:i:;vvi:.,,ii;icccii,i::,i:i;;icc7Y7cY7Xcc;cn:
' :M198boAU1Ycii......,ii;ii,..i:;ic;;,,,ii;i;:;77;i:i,:,i:ii;iccYccvC7ci7cz:
'  MQ7IE6nZAz7Yv;.:,:,i::::,:.,:;7Yi;ii...:,:,;v1oS7Y;ii;i;iccc;Ycc;7YX7Y;t$
'   M1X67YZQotCXvcv;i;:i,,,:.i:iYociiYcv:ivtU#W9zncX7Y;Y;;;vi;;civ;ccXYY:i@
'   b$;S1:;z21n7ttnvviii:.,,iivvCoII$#B8bZEbE0b1Y:,:vvYvvi;i;;c;i;YvYcXXb@
'    MUSt:.cnz1ztznYi;i;:iiii;;X7XnA8QB#Zbb$@M@#USv:.:i;;viv;vi;icc7c16M6
'     @zIi.,CoztCc7Y7;c;;i;i;;c;;:::nQMMMU9@MMMMMMM#2v;icvv;ccc;v;cv71Q
'      Mv1t;;SSC77v777YY;vi;;Yci..;b@MMMMZ71n0@@MMMMMMMBX7vccci;;cvccQ
'       @2t;itAtXYYvccYc7v;;c;::tEMMMMM$ACzXCXSoA299B@M@Q7cvvi;ivvcvc$
'        @QziYnAt17vvY;ccc;YYi;$MMMMEEUZb0W#WB0$bQWBAzCoz;:;ivvc;cY7t@
'          :t0@ZSC7c7cv;c;;i;;@MM@#E0B#@@922IttCzz9n7YCXYii:;vc;cv7tI@
'             2M#t77;vvciv;ciY@MW68$$$6zttYX7XYCC7cci;ivvYccc7c7YYCUzQ#
'               #Q1YYvYv;i;;;vtCStC7CYYX1oBQW0E6UC17c;cc7c7Y7Yt77XAIooE
'                MbStC;cvc;i:iic7t7Yc77t7SU9zzSSXX;;;c7t7CXnXt7tCzII7oQ
'                MQz2nXiY77;;;Y77Y77oXv;Y;;;;;;i;iiiYYCYtC7c1Cto0Eo7X7@v
'                Mz2A9nt7t777tcXYX7X7t;v;;:iiciii;iv;7vY7SXtoA8WZICY7X2@
'                 @cU082o7tXt77vcv7Xt7Y;;iiivYcicctX1t177X260EWZ17171Y7EMM
'                 M7;S8$8UznCn1XcXY7YXnAt7YcYC7CXCtStSSUUb0Q009z7t717Y78#MM.
'                AMAYi7IQbE9ASZU69UCtn2zA221nSzton2nA6EEWQWE0ASCXCtYXtAW$8#M:
'                M0E1c;tnA800$BW0W0bA8A9ZbI8U6I89000EQ000$W$E27tt171nA0WUEQ$$o
'                #690StX1C1SEW#$$QQbQQBQQE00QE0EQQ$WBQ0b0E02on171XSI98Q8EE0Q@E.
'                @I8b0bU7Yc7tA9EE#W##B0Q0W0W000WQB0QE0b86Unn7t77Y1b$6Z8QB#0$@X
'               $M0EEZE6ZUz7cct726Q##QBW$0QE#BBW$092Z9Z2ASoC7vc78Q8UA9BB#W8X,
'               Z0EWQQE0E0b0ZCv7711zIE0QEEb8Z0ZEAIo6I66AnzXvv1IQ0029E#MMZv   ..
'               Uv00BB$QWE0bWQQ9AXCCzoI2AU9U899IZzzo2oA1SC2ZQ09oA9WWMMb.   .,..
'              0..CUb$W$B@#WbEEWQ0AUS2n226oA29zonU2zz6SzSzb@@B7cz@MM0i   . ....
'           2Mb.  ..i10##$@##B0AZI9WBA7vt2U2U122AIAzEzC128EnIbEZMMW;  .......
'         ;YX.  ...  ..;70$B#@$$Q61oU@Qc,:v1zz121IS271oUSoYv;Q@Wzi  .,........